//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
//

#include "BatteryCSMAMacLayer.h"

Define_Module( BatteryCSMAMacLayer );

void BatteryCSMAMacLayer::setToLowTxPower()
{
	Enter_Method_Silent();
	txPower = par("txPower");
}

void BatteryCSMAMacLayer::setToHighTwPower()
{
	Enter_Method_Silent();
	txPower = par("highTxPower");
}

void BatteryCSMAMacLayer::handleHostState(const HostState& state)
{
	HostState::States hostState = state.get();

	switch (hostState) {
	case HostState::FAILED:
		EV<< "t = " << simTime() << " host state FAILED" << endl;
		break;
	case HostState::ACTIVE:
		EV<< "t = " << simTime() << " host in ACTIVE state" << endl;
		break;
	case HostState::SLEEP:
		EV<< "t = " << simTime() << " host switches to SLEEP state" << endl;
		break;
	default:
		break;
	}
}


